; Add a few things that make Scheme a little nicer
(define (caaaar l) (caar (caar l)))
(define (cdaaar l) (cdar (caar l)))
(define (cadaar l) (cadr (caar l)))
(define (cddaar l) (cddr (caar l)))
(define (caadar l) (caar (cdar l)))
(define (cdadar l) (cdar (cdar l)))
(define (caddar l) (cadr (cdar l)))
(define (cdddar l) (cddr (cdar l)))
(define (caaadr l) (caar (cadr l)))
(define (cdaadr l) (cdar (cadr l)))
(define (cadadr l) (cadr (cadr l)))
(define (cddadr l) (cddr (cadr l)))
(define (caaddr l) (caar (cddr l)))
(define (cdaddr l) (cdar (cddr l)))
(define (cadddr l) (cadr (cddr l)))
(define (cddddr l) (cddr (cddr l)))

(define (<= x y)
  (or (< x y) (= x y)))

(define (>= x y)
  (or (> x y) (= x y)))

(define viewer-command "gvu")
(define lpr-command "lpr")

(define (exec-siod)
  (execute-interpreter-command 'SIOD))

(define (exec-c)
  (execute-interpreter-command 'C))

(define (exec-guile)
  (execute-interpreter-command 'Guile))

(define (exec-python)
  (execute-interpreter-command 'Python))

(define (exec-tcl)
  (execute-interpreter-command 'Tcl))

(define (execute-extended-command)
  (exec-siod))

(define (llpr x)
  (puts x))

(define (do-help helpfile)
  (spawn (string-append siaghelp " file:" docdir "/" helpfile)))

(define (do-link url)
  (spawn (string-append siaghelp " " url)))

(define (help-for-help)
  (do-help "common/siaghelp.html"))

(define (help-search)
  (do-help "common/search.html"))

(define (help-copyright)
  (do-help "common/COPYING"))

(define (keyboard-quit)
  (llpr "Quit"))

(define (no-op)
  (llpr "This command does nothing"))

